from django.db.models import Q

from inspect_report.models import Team, Country, Seat


def get_team_names(city_id, country_id, team_id=None):
    if team_id is not None and team_id != '':
        team_names = Team.objects.filter(id=team_id).values_list('name')
    else:
        # # 获取坐席团队关系
        team_names = list()
        if city_id and country_id:
            team_names = Team.objects.filter(country_id=country_id).values_list('name')
        elif city_id and (country_id is None or country_id == ''):
            city = Country.objects.filter(id=city_id).first()
            if city.parent is None:
                team_names = Team.objects.filter().values_list('name')
            else:
                country_id_list = Country.objects.filter(Q(parent=city_id) | Q(id=city_id)).values_list('id')
                team_names = Team.objects.filter(country_id__in=country_id_list).values_list('name')
    return team_names


def get_agent_name(city_id, country_id, team_id, agent_name):
    if agent_name is not None and agent_name != '':
        return [agent_name]
    elif team_id is not None and team_id != '':
        return Seat.objects.filter(team_id=team_id).values_list('code')
    elif country_id is not None and country_id != '':
        team_ids = Team.objects.filter(country_id=country_id).values_list('id')
        return Seat.objects.filter(team_id__in=team_ids).values_list('code')
    elif city_id is not None and city_id != '':
        city = Country.objects.filter(id=city_id).first()
        if city.parent is None:
            return []
        else:
            country_id_list = Country.objects.filter(Q(parent=city_id) | Q(id=city_id)).values_list('id')
            return Team.objects.filter(country_id__in=country_id_list).values_list('code')
    else:
        return []


